## GtkPrintOperation

GtkPrintOperation — High-level Printing API

## Functions

GtkPrintOperation * | gtk_print_operation_new ()
void | gtk_print_operation_set_allow_async ()
void | gtk_print_operation_get_error ()
void | gtk_print_operation_set_default_page_setup ()
GtkPageSetup * | gtk_print_operation_get_default_page_setup ()
void | gtk_print_operation_set_print_settings ()
GtkPrintSettings * | gtk_print_operation_get_print_settings ()
void | gtk_print_operation_set_job_name ()
void | gtk_print_operation_set_n_pages ()
gint | gtk_print_operation_get_n_pages_to_print ()
void | gtk_print_operation_set_current_page ()
void | gtk_print_operation_set_use_full_page ()
void | gtk_print_operation_set_unit ()
void | gtk_print_operation_set_export_filename ()
void | gtk_print_operation_set_show_progress ()
void | gtk_print_operation_set_track_print_status ()
void | gtk_print_operation_set_custom_tab_label ()
GtkPrintOperationResult | gtk_print_operation_run ()
void | gtk_print_operation_cancel ()
void | gtk_print_operation_draw_page_finish ()
void | gtk_print_operation_set_defer_drawing ()
GtkPrintStatus | gtk_print_operation_get_status ()
const gchar * | gtk_print_operation_get_status_string ()
gboolean | gtk_print_operation_is_finished ()
void | gtk_print_operation_set_support_selection ()
gboolean | gtk_print_operation_get_support_selection ()
void | gtk_print_operation_set_has_selection ()
gboolean | gtk_print_operation_get_has_selection ()
void | gtk_print_operation_set_embed_page_setup ()
gboolean | gtk_print_operation_get_embed_page_setup ()
GtkPageSetup * | gtk_print_run_page_setup_dialog ()
void | (*GtkPageSetupDoneFunc) ()
void | gtk_print_run_page_setup_dialog_async ()
void | gtk_print_operation_preview_end_preview ()
gboolean | gtk_print_operation_preview_is_selected ()
void | gtk_print_operation_preview_render_page ()

## Properties

gboolean | allow-async | Read / Write
gint | current-page | Read / Write
gchar * | custom-tab-label | Read / Write
GtkPageSetup * | default-page-setup | Read / Write
gboolean | embed-page-setup | Read / Write
gchar * | export-filename | Read / Write
gboolean | has-selection | Read / Write
gchar * | job-name | Read / Write
gint | n-pages | Read / Write
gint | n-pages-to-print | Read
GtkPrintSettings * | print-settings | Read / Write
gboolean | show-progress | Read / Write
GtkPrintStatus | status | Read
gchar * | status-string | Read
gboolean | support-selection | Read / Write
gboolean | track-print-status | Read / Write
GtkUnit | unit | Read / Write
gboolean | use-full-page | Read / Write

## Signals

void | begin-print | Run Last
GObject* | create-custom-widget | Run Last
void | custom-widget-apply | Run Last
void | done | Run Last
void | draw-page | Run Last
void | end-print | Run Last
gboolean | paginate | Run Last
gboolean | preview | Run Last
void | request-page-setup | Run Last
void | status-changed | Run Last
void | update-custom-widget | Run Last
void | got-page-size | Run Last
void | ready | Run Last

## Types and Values

struct | GtkPrintOperation
struct | GtkPrintOperationClass
enum | GtkPrintStatus
enum | GtkPrintOperationAction
enum | GtkPrintOperationResult
enum | GtkPrintError
#define | GTK_PRINT_ERROR
| GtkPrintOperationPreview

## Object Hierarchy

        GInterface
        ╰── GtkPrintOperationPreview
        GObject
        ╰── GtkPrintOperation

## Prerequisites

GtkPrintOperationPreview requires GObject.

## Implemented Interfaces

GtkPrintOperation implements GtkPrintOperationPreview.

## Known Implementations

GtkPrintOperationPreview is implemented by GtkPrintOperation.

## Includes

    #include <gtk/gtk.h>

## Description

GtkPrintOperation is the high-level, portable printing API. It looks a bit different than other GTK+ dialogs such as the GtkFileChooser, since some platforms don’t expose enough infrastructure to implement a good print dialog. On such platforms, GtkPrintOperation uses the native print dialog. On platforms which do not provide a native print dialog, GTK+ uses its own, see GtkPrintUnixDialog.

The typical way to use the high-level printing API is to create a GtkPrintOperation object with `gtk_print_operation_new()` when the user selects to print. Then you set some properties on it, e.g. the page size, any GtkPrintSettings from previous print operations, the number of pages, the current page, etc.

Then you start the print operation by calling `gtk_print_operation_run()`. It will then show a dialog, let the user select a printer and options. When the user finished the dialog various signals will be emitted on the GtkPrintOperation, the main one being “draw-page”, which you are supposed to catch and render the page on the provided GtkPrintContext using Cairo.

### The high-level printing API

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28

    static GtkPrintSettings *settings = NULL;

    static void
    do_print (void)
    {
      GtkPrintOperation *print;
      GtkPrintOperationResult res;

      print = gtk_print_operation_new ();

      if (settings != NULL)
        gtk_print_operation_set_print_settings (print, settings);

      g_signal_connect (print, "begin_print", G_CALLBACK (begin_print), NULL);
      g_signal_connect (print, "draw_page", G_CALLBACK (draw_page), NULL);

      res = gtk_print_operation_run (print, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG,
                                     GTK_WINDOW (main_window), NULL);

      if (res == GTK_PRINT_OPERATION_RESULT_APPLY)
        {
          if (settings != NULL)
            g_object_unref (settings);
          settings = g_object_ref (gtk_print_operation_get_print_settings (print));
        }

      g_object_unref (print);
    }

By default GtkPrintOperation uses an external application to do print preview. To implement a custom print preview, an application must connect to the preview signal. The functions `gtk_print_operation_preview_render_page()`, `gtk_print_operation_preview_end_preview()` and `gtk_print_operation_preview_is_selected()` are useful when implementing a print preview.

## Functions

### gtk_print_operation_new ()

    GtkPrintOperation *
    gtk_print_operation_new (void);

Creates a new GtkPrintOperation.

#### Returns

a new GtkPrintOperation

Since 2.10

### gtk_print_operation_set_allow_async ()

    void
    gtk_print_operation_set_allow_async (GtkPrintOperation *op,
                                         gboolean allow_async);

Sets whether the `gtk_print_operation_run()` may return before the print operation is completed. Note that some platforms may not allow asynchronous operation.

#### Parameters

op | a GtkPrintOperation |
allow_async | `TRUE` to allow asynchronous operation |

Since 2.10

### gtk_print_operation_get_error ()

    void
    gtk_print_operation_get_error (GtkPrintOperation *op,
                                   GError **error);

Call this when the result of a print operation is `GTK_PRINT_OPERATION_RESULT_ERROR`, either as returned by `gtk_print_operation_run()`, or in the “done” signal handler. The returned GError will contain more details on what went wrong.

#### Parameters

op | a GtkPrintOperation |
error | return location for the error |

Since 2.10

### gtk_print_operation_set_default_page_setup ()

    void
    gtk_print_operation_set_default_page_setup
                                   (GtkPrintOperation *op,
                                    GtkPageSetup *default_page_setup);

Makes `default_page_setup` the default page setup for `op` .

This page setup will be used by `gtk_print_operation_run()`, but it can be overridden on a per-page basis by connecting to the “request-page-setup” signal.

#### Parameters

op | a GtkPrintOperation |
default_page_setup | a GtkPageSetup, or `NULL`. | [allow-none]

Since 2.10

### gtk_print_operation_get_default_page_setup ()

    GtkPageSetup *
    gtk_print_operation_get_default_page_setup
                                   (GtkPrintOperation *op);

Returns the default page setup, see `gtk_print_operation_set_default_page_setup()`.

#### Parameters

op | a GtkPrintOperation |

#### Returns

the default page setup.

[transfer none]

Since 2.10

### gtk_print_operation_set_print_settings ()

    void
    gtk_print_operation_set_print_settings
                                   (GtkPrintOperation *op,
                                    GtkPrintSettings *print_settings);

Sets the print settings for `op` . This is typically used to re-establish print settings from a previous print operation, see `gtk_print_operation_run()`.

#### Parameters

op | a GtkPrintOperation |
print_settings | GtkPrintSettings. | [allow-none]

Since 2.10

### gtk_print_operation_get_print_settings ()

    GtkPrintSettings *
    gtk_print_operation_get_print_settings
                                   (GtkPrintOperation *op);

Returns the current print settings.

Note that the return value is `NULL` until either `gtk_print_operation_set_print_settings()` or `gtk_print_operation_run()` have been called.

#### Parameters

op | a GtkPrintOperation |

#### Returns

the current print settings of `op` .

[transfer none]

Since 2.10

### gtk_print_operation_set_job_name ()

    void
    gtk_print_operation_set_job_name (GtkPrintOperation *op,
                                      const gchar *job_name);

Sets the name of the print job. The name is used to identify the job (e.g. in monitoring applications like eggcups).

If you don’t set a job name, GTK+ picks a default one by numbering successive print jobs.

#### Parameters

op | a GtkPrintOperation |
job_name | a string that identifies the print job |

Since 2.10

### gtk_print_operation_set_n_pages ()

    void
    gtk_print_operation_set_n_pages (GtkPrintOperation *op,
                                     gint n_pages);

Sets the number of pages in the document.

This must be set to a positive number before the rendering starts. It may be set in a “begin-print” signal hander.

Note that the page numbers passed to the “request-page-setup” and “draw-page” signals are 0-based, i.e. if the user chooses to print all pages, the last ::draw-page signal will be for page `n_pages` - 1.

#### Parameters

op | a GtkPrintOperation |
n_pages | the number of pages |

Since 2.10

### gtk_print_operation_get_n_pages_to_print ()

    gint
    gtk_print_operation_get_n_pages_to_print
                                   (GtkPrintOperation *op);

Returns the number of pages that will be printed.

Note that this value is set during print preparation phase (`GTK_PRINT_STATUS_PREPARING`), so this function should never be called before the data generation phase (`GTK_PRINT_STATUS_GENERATING_DATA`). You can connect to the “status-changed” signal and call `gtk_print_operation_get_n_pages_to_print()` when print status is `GTK_PRINT_STATUS_GENERATING_DATA`. This is typically used to track the progress of print operation.

#### Parameters

op | a GtkPrintOperation |

#### Returns

the number of pages that will be printed

Since 2.18

### gtk_print_operation_set_current_page ()

    void
    gtk_print_operation_set_current_page (GtkPrintOperation *op,
                                          gint current_page);

Sets the current page.

If this is called before `gtk_print_operation_run()`, the user will be able to select to print only the current page.

Note that this only makes sense for pre-paginated documents.

#### Parameters

op | a GtkPrintOperation |
current_page | the current page, 0-based |

Since 2.10

### gtk_print_operation_set_use_full_page ()

    void
    gtk_print_operation_set_use_full_page (GtkPrintOperation *op,
                                           gboolean full_page);

If `full_page` is `TRUE`, the transformation for the cairo context obtained from GtkPrintContext puts the origin at the top left corner of the page (which may not be the top left corner of the sheet, depending on page orientation and the number of pages per sheet). Otherwise, the origin is at the top left corner of the imageable area (i.e. inside the margins).

#### Parameters

op | a GtkPrintOperation |
full_page | `TRUE` to set up the GtkPrintContext for the full page |

Since 2.10

### gtk_print_operation_set_unit ()

    void
    gtk_print_operation_set_unit (GtkPrintOperation *op,
                                  GtkUnit unit);

Sets up the transformation for the cairo context obtained from GtkPrintContext in such a way that distances are measured in units of `unit` .

#### Parameters

op | a GtkPrintOperation |
unit | the unit to use |

Since 2.10

### gtk_print_operation_set_export_filename ()

    void
    gtk_print_operation_set_export_filename
                                   (GtkPrintOperation *op,
                                    const gchar *filename);

Sets up the GtkPrintOperation to generate a file instead of showing the print dialog. The indended use of this function is for implementing “Export to PDF” actions. Currently, PDF is the only supported format.

“Print to PDF” support is independent of this and is done by letting the user pick the “Print to PDF” item from the list of printers in the print dialog.

#### Parameters

op | a GtkPrintOperation |
filename | the filename for the exported file. | [type filename]

Since 2.10

### gtk_print_operation_set_show_progress ()

    void
    gtk_print_operation_set_show_progress (GtkPrintOperation *op,
                                           gboolean show_progress);

If `show_progress` is `TRUE`, the print operation will show a progress dialog during the print operation.

#### Parameters

op | a GtkPrintOperation |
show_progress | `TRUE` to show a progress dialog |

Since 2.10

### gtk_print_operation_set_track_print_status ()

    void
    gtk_print_operation_set_track_print_status
                                   (GtkPrintOperation *op,
                                    gboolean track_status);

If track_status is `TRUE`, the print operation will try to continue report on the status of the print job in the printer queues and printer. This can allow your application to show things like “out of paper” issues, and when the print job actually reaches the printer.

This function is often implemented using some form of polling, so it should not be enabled unless needed.

#### Parameters

op | a GtkPrintOperation |
track_status | `TRUE` to track status after printing |

Since 2.10

### gtk_print_operation_set_custom_tab_label ()

    void
    gtk_print_operation_set_custom_tab_label
                                   (GtkPrintOperation *op,
                                    const gchar *label);

Sets the label for the tab holding custom widgets.

#### Parameters

op | a GtkPrintOperation |
label | the label to use, or `NULL` to use the default label. | [allow-none]

Since 2.10

### gtk_print_operation_run ()

    GtkPrintOperationResult
    gtk_print_operation_run (GtkPrintOperation *op,
                             GtkPrintOperationAction action,
                             GtkWindow *parent,
                             GError **error);

Runs the print operation, by first letting the user modify print settings in the print dialog, and then print the document.

Normally that this function does not return until the rendering of all pages is complete. You can connect to the “status-changed” signal on `op` to obtain some information about the progress of the print operation. Furthermore, it may use a recursive mainloop to show the print dialog.

If you call `gtk_print_operation_set_allow_async()` or set the “allow-async” property the operation will run asynchronously if this is supported on the platform. The “done” signal will be emitted with the result of the operation when the it is done (i.e. when the dialog is canceled, or when the print succeeds or fails).

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35

    if (settings != NULL)
      gtk_print_operation_set_print_settings (print, settings);

    if (page_setup != NULL)
      gtk_print_operation_set_default_page_setup (print, page_setup);

    g_signal_connect (print, "begin-print",
                      G_CALLBACK (begin_print), &data);
    g_signal_connect (print, "draw-page",
                      G_CALLBACK (draw_page), &data);

    res = gtk_print_operation_run (print,
                                   GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG,
                                   parent,
                                   &error);

    if (res == GTK_PRINT_OPERATION_RESULT_ERROR)
     {
       error_dialog = gtk_message_dialog_new (GTK_WINDOW (parent),
                                     GTK_DIALOG_DESTROY_WITH_PARENT,
                             GTK_MESSAGE_ERROR,
                             GTK_BUTTONS_CLOSE,
                             "Error printing file:\n%s",
                             error->message);
       g_signal_connect (error_dialog, "response",
                         G_CALLBACK (gtk_widget_destroy), NULL);
       gtk_widget_show (error_dialog);
       g_error_free (error);
     }
    else if (res == GTK_PRINT_OPERATION_RESULT_APPLY)
     {
       if (settings != NULL)
    g_object_unref (settings);
       settings = g_object_ref (gtk_print_operation_get_print_settings (print));
     }

Note that `gtk_print_operation_run()` can only be called once on a given GtkPrintOperation.

#### Parameters

op | a GtkPrintOperation |
action | the action to start |
parent | Transient parent of the dialog. | [allow-none]
error | Return location for errors, or `NULL`. | [allow-none]

#### Returns

the result of the print operation. A return value of `GTK_PRINT_OPERATION_RESULT_APPLY` indicates that the printing was completed successfully. In this case, it is a good idea to obtain the used print settings with `gtk_print_operation_get_print_settings()` and store them for reuse with the next print operation. A value of `GTK_PRINT_OPERATION_RESULT_IN_PROGRESS` means the operation is running asynchronously, and will emit the “done” signal when done.

Since 2.10

### gtk_print_operation_cancel ()

    void
    gtk_print_operation_cancel (GtkPrintOperation *op);

Cancels a running print operation. This function may be called from a “begin-print”, “paginate” or “draw-page” signal handler to stop the currently running print operation.

#### Parameters

op | a GtkPrintOperation |

Since 2.10

### gtk_print_operation_draw_page_finish ()

    void
    gtk_print_operation_draw_page_finish (GtkPrintOperation *op);

Signalize that drawing of particular page is complete.

It is called after completion of page drawing (e.g. drawing in another thread). If `gtk_print_operation_set_defer_drawing()` was called before, then this function has to be called by application. In another case it is called by the library itself.

#### Parameters

op | a GtkPrintOperation |

Since 2.16

### gtk_print_operation_set_defer_drawing ()

    void
    gtk_print_operation_set_defer_drawing (GtkPrintOperation *op);

Sets up the GtkPrintOperation to wait for calling of `gtk_print_operation_draw_page_finish()` from application. It can be used for drawing page in another thread.

This function must be called in the callback of “draw-page” signal.

#### Parameters

op | a GtkPrintOperation |

Since 2.16

### gtk_print_operation_get_status ()

    GtkPrintStatus
    gtk_print_operation_get_status (GtkPrintOperation *op);

Returns the status of the print operation. Also see `gtk_print_operation_get_status_string()`.

#### Parameters

op | a GtkPrintOperation |

#### Returns

the status of the print operation

Since 2.10

### gtk_print_operation_get_status_string ()

    const gchar *
    gtk_print_operation_get_status_string (GtkPrintOperation *op);

Returns a string representation of the status of the print operation. The string is translated and suitable for displaying the print status e.g. in a GtkStatusbar.

Use `gtk_print_operation_get_status()` to obtain a status value that is suitable for programmatic use.

#### Parameters

op | a GtkPrintOperation |

#### Returns

a string representation of the status of the print operation

Since 2.10

### gtk_print_operation_is_finished ()

    gboolean
    gtk_print_operation_is_finished (GtkPrintOperation *op);

A convenience function to find out if the print operation is finished, either successfully (`GTK_PRINT_STATUS_FINISHED`) or unsuccessfully (`GTK_PRINT_STATUS_FINISHED_ABORTED`).

Note: when you enable print status tracking the print operation can be in a non-finished state even after done has been called, as the operation status then tracks the print job status on the printer.

#### Parameters

op | a GtkPrintOperation |

#### Returns

`TRUE`, if the print operation is finished.

Since 2.10

### gtk_print_operation_set_support_selection ()

    void
    gtk_print_operation_set_support_selection
                                   (GtkPrintOperation *op,
                                    gboolean support_selection);

Sets whether selection is supported by GtkPrintOperation.

#### Parameters

op | a GtkPrintOperation |
support_selection | `TRUE` to support selection |

Since 2.18

### gtk_print_operation_get_support_selection ()

    gboolean
    gtk_print_operation_get_support_selection
                                   (GtkPrintOperation *op);

Gets the value of “support-selection” property.

#### Parameters

op | a GtkPrintOperation |

#### Returns

whether the application supports print of selection

Since 2.18

### gtk_print_operation_set_has_selection ()

    void
    gtk_print_operation_set_has_selection (GtkPrintOperation *op,
                                           gboolean has_selection);

Sets whether there is a selection to print.

Application has to set number of pages to which the selection will draw by `gtk_print_operation_set_n_pages()` in a callback of “begin-print”.

#### Parameters

op | a GtkPrintOperation |
has_selection | `TRUE` indicates that a selection exists |

Since 2.18

### gtk_print_operation_get_has_selection ()

    gboolean
    gtk_print_operation_get_has_selection (GtkPrintOperation *op);

Gets the value of “has-selection” property.

#### Parameters

op | a GtkPrintOperation |

#### Returns

whether there is a selection

Since 2.18

### gtk_print_operation_set_embed_page_setup ()

    void
    gtk_print_operation_set_embed_page_setup
                                   (GtkPrintOperation *op,
                                    gboolean embed);

Embed page size combo box and orientation combo box into page setup page. Selected page setup is stored as default page setup in GtkPrintOperation.

#### Parameters

op | a GtkPrintOperation |
embed | `TRUE` to embed page setup selection in the GtkPrintUnixDialog |

Since 2.18

### gtk_print_operation_get_embed_page_setup ()

    gboolean
    gtk_print_operation_get_embed_page_setup
                                   (GtkPrintOperation *op);

Gets the value of “embed-page-setup” property.

#### Parameters

op | a GtkPrintOperation |

#### Returns

whether page setup selection combos are embedded

Since 2.18

### gtk_print_run_page_setup_dialog ()

    GtkPageSetup *
    gtk_print_run_page_setup_dialog (GtkWindow *parent,
                                     GtkPageSetup *page_setup,
                                     GtkPrintSettings *settings);

Runs a page setup dialog, letting the user modify the values from `page_setup` . If the user cancels the dialog, the returned GtkPageSetup is identical to the passed in `page_setup` , otherwise it contains the modifications done in the dialog.

Note that this function may use a recursive mainloop to show the page setup dialog. See `gtk_print_run_page_setup_dialog_async()` if this is a problem.

#### Parameters

parent | transient parent. | [allow-none]
page_setup | an existing GtkPageSetup. | [allow-none]
settings | a GtkPrintSettings |

#### Returns

a new GtkPageSetup.

[transfer full]

Since 2.10

### GtkPageSetupDoneFunc ()

    void
    (*GtkPageSetupDoneFunc) (GtkPageSetup *page_setup,
                             gpointer data);

The type of function that is passed to `gtk_print_run_page_setup_dialog_async()`.

This function will be called when the page setup dialog is dismissed, and also serves as destroy notify for `data` .

#### Parameters

page_setup | the GtkPageSetup that has been |
data | user data that has been passed to `gtk_print_run_page_setup_dialog_async()`. | [closure]

### gtk_print_run_page_setup_dialog_async ()

    void
    gtk_print_run_page_setup_dialog_async (GtkWindow *parent,
                                           GtkPageSetup *page_setup,
                                           GtkPrintSettings *settings,
                                           GtkPageSetupDoneFunc done_cb,
                                           gpointer data);

Runs a page setup dialog, letting the user modify the values from `page_setup` .

In contrast to `gtk_print_run_page_setup_dialog()`, this function returns after showing the page setup dialog on platforms that support this, and calls `done_cb` from a signal handler for the ::response signal of the dialog.

#### Parameters

parent | transient parent, or `NULL`. | [allow-none]
page_setup | an existing GtkPageSetup, or `NULL`. | [allow-none]
settings | a GtkPrintSettings |
done_cb | a function to call when the user saves the modified page setup. | [scope async]
data | user data to pass to `done_cb` |

Since 2.10

### gtk_print_operation_preview_end_preview ()

    void
    gtk_print_operation_preview_end_preview
                                   (GtkPrintOperationPreview *preview);

Ends a preview.

This function must be called to finish a custom print preview.

#### Parameters

preview | a GtkPrintOperationPreview |

Since 2.10

### gtk_print_operation_preview_is_selected ()

    gboolean
    gtk_print_operation_preview_is_selected
                                   (GtkPrintOperationPreview *preview,
                                    gint page_nr);

Returns whether the given page is included in the set of pages that have been selected for printing.

#### Parameters

preview | a GtkPrintOperationPreview |
page_nr | a page number |

#### Returns

`TRUE` if the page has been selected for printing

Since 2.10

### gtk_print_operation_preview_render_page ()

    void
    gtk_print_operation_preview_render_page
                                   (GtkPrintOperationPreview *preview,
                                    gint page_nr);

Renders a page to the preview, using the print context that was passed to the “preview” handler together with `preview` .

A custom iprint preview should use this function in its ::expose handler to render the currently selected page.

Note that this function requires a suitable cairo context to be associated with the print context.

#### Parameters

preview | a GtkPrintOperationPreview |
page_nr | the page to render |

Since 2.10

## Types and Values

### struct GtkPrintOperation

    struct GtkPrintOperation;

### struct GtkPrintOperationClass

    struct GtkPrintOperationClass {
      GObjectClass parent_class;

      void     (*done)               (GtkPrintOperation *operation,
                                      GtkPrintOperationResult result);
      void     (*begin_print)        (GtkPrintOperation *operation,
                                      GtkPrintContext   *context);
      gboolean (*paginate)           (GtkPrintOperation *operation,
                                      GtkPrintContext   *context);
      void     (*request_page_setup) (GtkPrintOperation *operation,
                                      GtkPrintContext   *context,
                                      gint               page_nr,
                                      GtkPageSetup      *setup);
      void     (*draw_page)          (GtkPrintOperation *operation,
                                      GtkPrintContext   *context,
                                      gint               page_nr);
      void     (*end_print)          (GtkPrintOperation *operation,
                                      GtkPrintContext   *context);
      void     (*status_changed)     (GtkPrintOperation *operation);

      GtkWidget *(*create_custom_widget) (GtkPrintOperation *operation);
      void       (*custom_widget_apply)  (GtkPrintOperation *operation,
                                          GtkWidget         *widget);

      gboolean (*preview)        (GtkPrintOperation        *operation,
                                  GtkPrintOperationPreview *preview,
                                  GtkPrintContext          *context,
                                  GtkWindow                *parent);

      void     (*update_custom_widget) (GtkPrintOperation *operation,
                                        GtkWidget         *widget,
                                        GtkPageSetup      *setup,
                                        GtkPrintSettings  *settings);
    };

#### Members

GObjectClass `parent_class`; | The parent class. |
`done` () | Signal emitted when the print operation run has finished doing everything required for printing. |
`begin_print` () | Signal emitted after the user has finished changing print settings in the dialog, before the actual rendering starts. |
`paginate` () | Signal emitted after the “begin-print” signal, but before the actual rendering starts. |
`request_page_setup` () | Emitted once for every page that is printed, to give the application a chance to modify the page setup. |
`draw_page` () | Signal emitted for every page that is printed. |
`end_print` () | Signal emitted after all pages have been rendered. |
`status_changed` () | Emitted at between the various phases of the print operation. |
`create_custom_widget` () | Signal emitted when displaying the print dialog. |
`custom_widget_apply` () | Signal emitted right before “begin-print” if you added a custom widget in the “create-custom-widget” handler. |
`preview` () | Signal emitted when a preview is requested from the native dialog. |
`update_custom_widget` () | Emitted after change of selected printer. |

### enum GtkPrintStatus

The status gives a rough indication of the completion of a running print operation.

#### Members

GTK_PRINT_STATUS_INITIAL | The printing has not started yet; this status is set initially, and while the print dialog is shown. |
GTK_PRINT_STATUS_PREPARING | This status is set while the begin-print signal is emitted and during pagination. |
GTK_PRINT_STATUS_GENERATING_DATA | This status is set while the pages are being rendered. |
GTK_PRINT_STATUS_SENDING_DATA | The print job is being sent off to the printer. |
GTK_PRINT_STATUS_PENDING | The print job has been sent to the printer, but is not printed for some reason, e.g. the printer may be stopped. |
GTK_PRINT_STATUS_PENDING_ISSUE | Some problem has occurred during printing, e.g. a paper jam. |
GTK_PRINT_STATUS_PRINTING | The printer is processing the print job. |
GTK_PRINT_STATUS_FINISHED | The printing has been completed successfully. |
GTK_PRINT_STATUS_FINISHED_ABORTED | The printing has been aborted. |

### enum GtkPrintOperationAction

The `action` parameter to `gtk_print_operation_run()` determines what action the print operation should perform.

#### Members

GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG | Show the print dialog. |
GTK_PRINT_OPERATION_ACTION_PRINT | Start to print without showing the print dialog, based on the current print settings. |
GTK_PRINT_OPERATION_ACTION_PREVIEW | Show the print preview. |
GTK_PRINT_OPERATION_ACTION_EXPORT | Export to a file. This requires the export-filename property to be set. |

### enum GtkPrintOperationResult

A value of this type is returned by `gtk_print_operation_run()`.

#### Members

GTK_PRINT_OPERATION_RESULT_ERROR | An error has occured. |
GTK_PRINT_OPERATION_RESULT_APPLY | The print settings should be stored. |
GTK_PRINT_OPERATION_RESULT_CANCEL | The print operation has been canceled, the print settings should not be stored. |
GTK_PRINT_OPERATION_RESULT_IN_PROGRESS | The print operation is not complete yet. This value will only be returned when running asynchronously. |

### enum GtkPrintError

Error codes that identify various errors that can occur while using the GTK+ printing support.

#### Members

GTK_PRINT_ERROR_GENERAL | An unspecified error occurred. |
GTK_PRINT_ERROR_INTERNAL_ERROR | An internal error occurred. |
GTK_PRINT_ERROR_NOMEM | A memory allocation failed. |
GTK_PRINT_ERROR_INVALID_FILE | An error occurred while loading a page setup or paper size from a key file. |

### GTK_PRINT_ERROR

    #define GTK_PRINT_ERROR gtk_print_error_quark ()

The error domain for GtkPrintError errors.

### GtkPrintOperationPreview

    typedef struct _GtkPrintOperationPreview GtkPrintOperationPreview;

## Property Details

### The `“allow-async”` property

      “allow-async”              gboolean

Determines whether the print operation may run asynchronously or not.

Some systems don't support asynchronous printing, but those that do will return `GTK_PRINT_OPERATION_RESULT_IN_PROGRESS` as the status, and emit the “done” signal when the operation is actually done.

The Windows port does not support asynchronous operation at all (this is unlikely to change). On other platforms, all actions except for `GTK_PRINT_OPERATION_ACTION_EXPORT` support asynchronous operation.

Flags: Read / Write

Default value: FALSE

Since 2.10

### The `“current-page”` property

      “current-page”             gint

The current page in the document.

If this is set before `gtk_print_operation_run()`, the user will be able to select to print only the current page.

Note that this only makes sense for pre-paginated documents.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since 2.10

### The `“custom-tab-label”` property

      “custom-tab-label”         gchar *

Used as the label of the tab containing custom widgets. Note that this property may be ignored on some platforms.

If this is `NULL`, GTK+ uses a default label.

Flags: Read / Write

Default value: NULL

Since 2.10

### The `“default-page-setup”` property

      “default-page-setup”       GtkPageSetup *

The GtkPageSetup used by default.

This page setup will be used by `gtk_print_operation_run()`, but it can be overridden on a per-page basis by connecting to the “request-page-setup” signal.

Flags: Read / Write

Since 2.10

### The `“embed-page-setup”` property

      “embed-page-setup”         gboolean

If `TRUE`, page size combo box and orientation combo box are embedded into page setup page.

Flags: Read / Write

Default value: FALSE

Since 2.18

### The `“export-filename”` property

      “export-filename”          gchar *

The name of a file to generate instead of showing the print dialog. Currently, PDF is the only supported format.

The intended use of this property is for implementing “Export to PDF” actions.

“Print to PDF” support is independent of this and is done by letting the user pick the “Print to PDF” item from the list of printers in the print dialog.

Flags: Read / Write

Default value: NULL

Since 2.10

### The `“has-selection”` property

      “has-selection”            gboolean

Determines whether there is a selection in your application. This can allow your application to print the selection. This is typically used to make a "Selection" button sensitive.

Flags: Read / Write

Default value: FALSE

Since 2.18

### The `“job-name”` property

      “job-name”                 gchar *

A string used to identify the job (e.g. in monitoring applications like eggcups).

If you don't set a job name, GTK+ picks a default one by numbering successive print jobs.

Flags: Read / Write

Default value: ""

Since 2.10

### The `“n-pages”` property

      “n-pages”                  gint

The number of pages in the document.

This must be set to a positive number before the rendering starts. It may be set in a “begin-print” signal hander.

Note that the page numbers passed to the “request-page-setup” and “draw-page” signals are 0-based, i.e. if the user chooses to print all pages, the last ::draw-page signal will be for page `n_pages` - 1.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since 2.10

### The `“n-pages-to-print”` property

      “n-pages-to-print”         gint

The number of pages that will be printed.

Note that this value is set during print preparation phase (`GTK_PRINT_STATUS_PREPARING`), so this value should never be get before the data generation phase (`GTK_PRINT_STATUS_GENERATING_DATA`). You can connect to the “status-changed” signal and call `gtk_print_operation_get_n_pages_to_print()` when print status is `GTK_PRINT_STATUS_GENERATING_DATA`. This is typically used to track the progress of print operation.

Flags: Read

Allowed values: >= -1

Default value: -1

Since 2.18

### The `“print-settings”` property

      “print-settings”           GtkPrintSettings *

The GtkPrintSettings used for initializing the dialog.

Setting this property is typically used to re-establish print settings from a previous print operation, see `gtk_print_operation_run()`.

Flags: Read / Write

Since 2.10

### The `“show-progress”` property

      “show-progress”            gboolean

Determines whether to show a progress dialog during the print operation.

Flags: Read / Write

Default value: FALSE

Since 2.10

### The `“status”` property

      “status”                   GtkPrintStatus

The status of the print operation.

Flags: Read

Default value: GTK_PRINT_STATUS_INITIAL

Since 2.10

### The `“status-string”` property

      “status-string”            gchar *

A string representation of the status of the print operation. The string is translated and suitable for displaying the print status e.g. in a GtkStatusbar.

See the “status” property for a status value that is suitable for programmatic use.

Flags: Read

Default value: ""

Since 2.10

### The `“support-selection”` property

      “support-selection”        gboolean

If `TRUE`, the print operation will support print of selection. This allows the print dialog to show a "Selection" button.

Flags: Read / Write

Default value: FALSE

Since 2.18

### The `“track-print-status”` property

      “track-print-status”       gboolean

If `TRUE`, the print operation will try to continue report on the status of the print job in the printer queues and printer. This can allow your application to show things like “out of paper” issues, and when the print job actually reaches the printer. However, this is often implemented using polling, and should not be enabled unless needed.

Flags: Read / Write

Default value: FALSE

Since 2.10

### The `“unit”` property

      “unit”                     GtkUnit

The transformation for the cairo context obtained from GtkPrintContext is set up in such a way that distances are measured in units of `unit` .

Flags: Read / Write

Default value: GTK_UNIT_NONE

Since 2.10

### The `“use-full-page”` property

      “use-full-page”            gboolean

If `TRUE`, the transformation for the cairo context obtained from GtkPrintContext puts the origin at the top left corner of the page (which may not be the top left corner of the sheet, depending on page orientation and the number of pages per sheet). Otherwise, the origin is at the top left corner of the imageable area (i.e. inside the margins).

Flags: Read / Write

Default value: FALSE

Since 2.10

## Signal Details

### The `“begin-print”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkPrintContext   *context,
                   gpointer           user_data)

Emitted after the user has finished changing print settings in the dialog, before the actual rendering starts.

A typical use for ::begin-print is to use the parameters from the GtkPrintContext and paginate the document accordingly, and then set the number of pages with `gtk_print_operation_set_n_pages()`.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
context | the GtkPrintContext for the current operation |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“create-custom-widget”` signal

    GObject*
    user_function (GtkPrintOperation *operation,
                   gpointer           user_data)

Emitted when displaying the print dialog. If you return a widget in a handler for this signal it will be added to a custom tab in the print dialog. You typically return a container widget with multiple widgets in it.

The print dialog owns the returned widget, and its lifetime is not controlled by the application. However, the widget is guaranteed to stay around until the “custom-widget-apply” signal is emitted on the operation. Then you can read out any information you need from the widgets.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
user_data | user data set when the signal handler was connected. |

#### Returns

A custom widget that gets embedded in the print dialog, or `NULL`.

[transfer none]

Flags: Run Last

Since 2.10

### The `“custom-widget-apply”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkWidget         *widget,
                   gpointer           user_data)

Emitted right before “begin-print” if you added a custom widget in the “create-custom-widget” handler. When you get this signal you should read the information from the custom widgets, as the widgets are not guaraneed to be around at a later time.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
widget | the custom widget added in create-custom-widget |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“done”` signal

    void
    user_function (GtkPrintOperation      *operation,
                   GtkPrintOperationResult result,
                   gpointer                user_data)

Emitted when the print operation run has finished doing everything required for printing.

`result` gives you information about what happened during the run. If `result` is `GTK_PRINT_OPERATION_RESULT_ERROR` then you can call `gtk_print_operation_get_error()` for more information.

If you enabled print status tracking then `gtk_print_operation_is_finished()` may still return `FALSE` after “done” was emitted.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
result | the result of the print operation |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“draw-page”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkPrintContext   *context,
                   gint               page_nr,
                   gpointer           user_data)

Emitted for every page that is printed. The signal handler must render the `page_nr` 's page onto the cairo context obtained from `context` using `gtk_print_context_get_cairo_context()`.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38

    static void
    draw_page (GtkPrintOperation *operation,
               GtkPrintContext   *context,
               gint               page_nr,
               gpointer           user_data)
    {
      cairo_t *cr;
      PangoLayout *layout;
      gdouble width, text_height;
      gint layout_height;
      PangoFontDescription *desc;

      cr = gtk_print_context_get_cairo_context (context);
      width = gtk_print_context_get_width (context);

      cairo_rectangle (cr, 0, 0, width, HEADER_HEIGHT);

      cairo_set_source_rgb (cr, 0.8, 0.8, 0.8);
      cairo_fill (cr);

      layout = gtk_print_context_create_pango_layout (context);

      desc = pango_font_description_from_string ("sans 14");
      pango_layout_set_font_description (layout, desc);
      pango_font_description_free (desc);

      pango_layout_set_text (layout, "some text", -1);
      pango_layout_set_width (layout, width * PANGO_SCALE);
      pango_layout_set_alignment (layout, PANGO_ALIGN_CENTER);

      pango_layout_get_size (layout, NULL, &layout_height);
      text_height = (gdouble)layout_height / PANGO_SCALE;

      cairo_move_to (cr, width / 2,  (HEADER_HEIGHT - text_height) / 2);
      pango_cairo_show_layout (cr, layout);

      g_object_unref (layout);
    }

Use `gtk_print_operation_set_use_full_page()` and `gtk_print_operation_set_unit()` before starting the print operation to set up the transformation of the cairo context according to your needs.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
context | the GtkPrintContext for the current operation |
page_nr | the number of the currently printed page (0-based) |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“end-print”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkPrintContext   *context,
                   gpointer           user_data)

Emitted after all pages have been rendered. A handler for this signal can clean up any resources that have been allocated in the “begin-print” handler.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
context | the GtkPrintContext for the current operation |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“paginate”` signal

    gboolean
    user_function (GtkPrintOperation *operation,
                   GtkPrintContext   *context,
                   gpointer           user_data)

Emitted after the “begin-print” signal, but before the actual rendering starts. It keeps getting emitted until a connected signal handler returns `TRUE`.

The ::paginate signal is intended to be used for paginating a document in small chunks, to avoid blocking the user interface for a long time. The signal handler should update the number of pages using `gtk_print_operation_set_n_pages()`, and return `TRUE` if the document has been completely paginated.

If you don't need to do pagination in chunks, you can simply do it all in the ::begin-print handler, and set the number of pages from there.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
context | the GtkPrintContext for the current operation |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if pagination is complete

Flags: Run Last

Since 2.10

### The `“preview”` signal

    gboolean
    user_function (GtkPrintOperation        *operation,
                   GtkPrintOperationPreview *preview,
                   GtkPrintContext          *context,
                   GtkWindow                *parent,
                   gpointer                  user_data)

Gets emitted when a preview is requested from the native dialog.

The default handler for this signal uses an external viewer application to preview.

To implement a custom print preview, an application must return `TRUE` from its handler for this signal. In order to use the provided `context` for the preview implementation, it must be given a suitable cairo context with `gtk_print_context_set_cairo_context()`.

The custom preview implementation can use `gtk_print_operation_preview_is_selected()` and `gtk_print_operation_preview_render_page()` to find pages which are selected for print and render them. The preview must be finished by calling `gtk_print_operation_preview_end_preview()` (typically in response to the user clicking a close button).

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
preview | the GtkPrintOperationPreview for the current operation |
context | the GtkPrintContext that will be used |
parent | the GtkWindow to use as window parent, or `NULL`. | [allow-none]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the listener wants to take over control of the preview

Flags: Run Last

Since 2.10

### The `“request-page-setup”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkPrintContext   *context,
                   gint               page_nr,
                   GtkPageSetup      *setup,
                   gpointer           user_data)

Emitted once for every page that is printed, to give the application a chance to modify the page setup. Any changes done to `setup` will be in force only for printing this page.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
context | the GtkPrintContext for the current operation |
page_nr | the number of the currently printed page (0-based) |
setup | the GtkPageSetup |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“status-changed”` signal

    void
    user_function (GtkPrintOperation *operation,
                   gpointer           user_data)

Emitted at between the various phases of the print operation. See GtkPrintStatus for the phases that are being discriminated. Use `gtk_print_operation_get_status()` to find out the current status.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.10

### The `“update-custom-widget”` signal

    void
    user_function (GtkPrintOperation *operation,
                   GtkWidget         *widget,
                   GtkPageSetup      *setup,
                   GtkPrintSettings  *settings,
                   gpointer           user_data)

Emitted after change of selected printer. The actual page setup and print settings are passed to the custom widget, which can actualize itself according to this change.

#### Parameters

operation | the GtkPrintOperation on which the signal was emitted |
widget | the custom widget added in create-custom-widget |
setup | actual page setup |
settings | actual print settings |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 2.18

### The `“got-page-size”` signal

    void
    user_function (GtkPrintOperationPreview *preview,
                   GtkPrintContext          *context,
                   GtkPageSetup             *page_setup,
                   gpointer                  user_data)

The ::got-page-size signal is emitted once for each page that gets rendered to the preview.

A handler for this signal should update the `context` according to `page_setup` and set up a suitable cairo context, using `gtk_print_context_set_cairo_context()`.

#### Parameters

preview | the object on which the signal is emitted |
context | the current GtkPrintContext |
page_setup | the GtkPageSetup for the current page |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“ready”` signal

    void
    user_function (GtkPrintOperationPreview *preview,
                   GtkPrintContext          *context,
                   gpointer                  user_data)

The ::ready signal gets emitted once per preview operation, before the first page is rendered.

A handler for this signal can be used for setup tasks.

#### Parameters

preview | the object on which the signal is emitted |
context | the current GtkPrintContext |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

## See Also

GtkPrintContext, GtkPrintUnixDialog